package szamok;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Random;
import java.util.Scanner;

public class Szamok {

	
	public static void main(String[] args) {
		ArrayList<Feladat> feladatok = new ArrayList<Feladat>();
		
		//1. feladat - adatbeolvass
		System.out.println("\n1. feladat");
		try {
			BufferedReader bw = new BufferedReader(new FileReader("felszam.txt"));
			String sor;
			while ((sor = bw.readLine()) != null) {
				Feladat ez = new Feladat(sor, bw.readLine().split(" "));
				feladatok.add(ez);
			}
			bw.close();
			
		} catch (Exception e) {
			System.out.println("Fjlolvassi vagy adat hiba: " + e.getMessage());
		}
		
		//2. feladat - krdsek szma
		System.out.println("\n2. feladat");
		System.out.println("Az adatfajlban " + feladatok.size() + " kerdes van.");
		
		//3. feladat- matematika feladatok szma pontrtkenknt
		System.out.println("\n3. feladat");
		int[] matPontDb = new int[4];
		for (Feladat feladat : feladatok) {
			if (feladat.getTema().compareTo("matematika") == 0) {
				matPontDb[0]++;
				matPontDb[feladat.getPont()]++;
			}		
			}
		System.out.print("Az adatfajlban " + matPontDb[0] +" matematika feladat van");
		for (int i = 1; i < matPontDb.length; i++) {
			System.out.print(", "+ i +" pontot er "+ matPontDb[i] + " feladat");			
		}
		System.out.println(".");
		
		//4. feladat - valaszok intervalluma
		System.out.println("\n4. feladat");
		int min = feladatok.get(0).getValasz();
		int max = feladatok.get(0).getValasz();
		for (Feladat feladat : feladatok) {
			if (feladat.getValasz() < min) {
				min = feladat.getValasz();
			}
			if (feladat.getValasz() > max) {
				max = feladat.getValasz();
			}
		}
		
		System.out.println("A vlaszok szmrtke a [" + min + ", " + max + "] intervallumban van.");
		
		//5. feladat - tmakrk kigyjtse
		System.out.println("\n5. feladat");
		ArrayList<String> temak = new ArrayList<String>();
		for (Feladat feladat : feladatok) {
			int i = 0;
			while (temak.size() >i && feladat.getTema().compareTo(temak.get(i))!= 0) {
				i++;
			}
			if (temak.size() == i) {
				temak.add(feladat.getTema());
			}
		}
		System.out.print("A krdsek tmakrei: ");
		for (String tema : temak) {
			System.out.print(tema + ", ");
		}
		System.out.println("\b\b ");
		
		//6. feladat - egy krds sorsolsa
		System.out.println("\n6. feladat");
		Scanner scan = new Scanner(System.in);
		Random rnd = new Random();
		
		System.out.print("Adja meg a tema nevet: ");
		String tema = scan.nextLine();
		for (Feladat feladat : feladatok) {
			if (feladat.getTema().compareTo(tema) == 0) {
				feladat.setSors(rnd.nextDouble());
			}
		}
		Feladat sorsolt = null;
		double sorsmax = 0.0;
		for (Feladat feladat : feladatok) {
			if (feladat.getSors() > sorsmax) {
				sorsmax = feladat.getSors();
				sorsolt = feladat;
			}
		}
		if (sorsolt != null) {
			System.out.print(sorsolt.getKerdes()+ " ");
			int valasz = scan.nextInt();
			scan.nextLine();
			if (sorsolt.getValasz() != valasz) {
				System.out.println("A valasz 0 pontot er.\nA helyes valasz: " + sorsolt.getValasz());
			}else{
				System.out.println("A valasz " + sorsolt.getPont() +"pontot er.");
			}
		}
		
		//7. feladat - krdssor generlsa
		System.out.println("\n7. feladat");
		for (Feladat feladat : feladatok) {
			feladat.setSors(rnd.nextDouble());
		}
		for (int i = 0; i < 10; i++) {
			int locmax = i;		
			for (int j = i + 1; j < feladatok.size(); j++) {
				if (feladatok.get(j).getSors()> feladatok.get(locmax).getSors()) {
					locmax = j;
				}
			}
			Feladat temp = feladatok.get(i);
			feladatok.set(i, feladatok.get(locmax));
			feladatok.set(locmax, temp);
		}
		
		try {
			PrintWriter pw = new PrintWriter(new FileWriter("tesztfel.txt"));
			int total = 0;
			for (int i = 0; i < 10; i++) {
				pw.println(feladatok.get(i).getPont() + " " + feladatok.get(i).getValasz() + " " + feladatok.get(i).getKerdes());
				total += feladatok.get(i).getPont();
			}
			
			pw.println();			
			pw.printf("A feladatsorra osszesen %d pont adhato.", total);
			
			pw.close();
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}	
		System.out.println("Kesz.");
		
		scan.nextLine();
	}

}
